# -*- coding: utf-8 -*-

import os


class AmzProductConverter():
  def __init__(self):
    pass

  def convert(self, data):
    return  {
      'title': data['title'],
      'description': self.get_description(data),
      'images': ';'.join(self.get_images(data))
    }

  def get_description(self, product_info):
    d = dict()
    attrs = product_info.get('attributes', d)
    desc = attrs.get('product_description', [d])[0].get('value', product_info.get('title', ''))

    features = product_info.get('attributes', d).get('bullet_point', [])
    features_list = []
    for feature in features:
      bullet = feature.get('value', None)
      if not bullet:
        continue

      features_list.append('<li>{}</li>'.format(bullet))

    return '<ul>{}</ul>{}'.format('\n'.join(features_list), desc)

  def get_images(self, product_info):
    images = product_info.get('images', [])

    if isinstance(images, str):
      images = [images]

    imgs = dict()
    for image in images:
        img_url = self.opt_img(image)
        if img_url in imgs:
          imgs[img_url] += 1
        else:
          imgs[img_url] = 1

    return list(imgs.keys())

  def opt_img(self, img):
    if '._' in img:
      filename = os.path.basename(img)
      parts = filename.split('.')
      filename = parts[0] + '.' + parts[len(parts) - 1]
      img = os.path.dirname(img) + '/' + filename

    return img
